view hgeditor @ 17401:a826b1d7f5b2

zsh completion: add new options for existing commands * backout: add --tool; * bisect: add --extend; * bookmarks: add --inactive; * branches: add --closed; * bundle: add --rev, --all, --branch; * cat: add --decode; * clone: add --updaterev, --branch, --pull and use common-with-qclone opts; * commit: add --close-branch; * diff: add --change, --reverse, --stat, --text, --unified; * export: add --rev; * grep: add --date; * heads: add --topo, --closed; * help: add --extension, --command, --keywords; complete additional help topics also, not commands only; * identify: add --bookmark and remote_opts; * import: add --no-commit, --exact, --import-branch, --date, --user, --similarity and commit options; * log: add --user, --date, --stat, --git, --graph; * manifest: add --rev; * push: add --new-branch; * resolve: add --all, --no-status, --tool and pattern options; * revert: add --date; * serve: add --prefix, --web-conf, --pid-file, --cmdserver, --certificate; * status: add --change; * tag: add --force, --edit, --remove; * tip: add --git; * update: add --check, --date.
author Nikolaj Sjujskij <sterkrig@myopera.com>
date Thu, 16 Aug 2012 19:03:01 +0400
parents 2b440bb8a66b
children 1aee2ab0f902
line wrap: on
line source

#!/bin/sh
#
# This is an example of using HGEDITOR to create of diff to review the
# changes while commiting.

# If you want to pass your favourite editor some other parameters
# only for Mercurial, modify this:
case "${EDITOR}" in
    "")
        EDITOR="vi"
        ;;
    emacs)
        EDITOR="$EDITOR -nw"
        ;;
    gvim|vim)
        EDITOR="$EDITOR -f -o"
        ;;
esac


HGTMP=""
cleanup_exit() {
    rm -rf "$HGTMP"
}

# Remove temporary files even if we get interrupted
trap "cleanup_exit" 0 # normal exit
trap "exit 255" HUP INT QUIT ABRT TERM

HGTMP=$(mktemp -d ${TMPDIR-/tmp}/hgeditor.XXXXXX)
[ x$HGTMP != x -a -d $HGTMP ] || {
  echo "Could not create temporary directory! Exiting." 1>&2
  exit 1
}

(
    grep '^HG: changed' "$1" | cut -b 13- | while read changed; do
        "$HG" diff "$changed" >> "$HGTMP/diff"
    done
)

cat "$1" > "$HGTMP/msg"

MD5=$(which md5sum 2>/dev/null) || \
    MD5=$(which md5 2>/dev/null)
[ -x "${MD5}" ] && CHECKSUM=`${MD5} "$HGTMP/msg"`
if [ -s "$HGTMP/diff" ]; then
    $EDITOR "$HGTMP/msg" "$HGTMP/diff" || exit $?
else
    $EDITOR "$HGTMP/msg" || exit $?
fi
[ -x "${MD5}" ] && (echo "$CHECKSUM" | ${MD5} -c >/dev/null 2>&1 && exit 13)

mv "$HGTMP/msg" "$1"

exit $?